﻿package
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;

	import flash.geom.Matrix; 
    import flash.display.GradientType;
	
	public class GraphicInterface extends Sprite
	{
		private var particles:Array;
		private var particleMC:Sprite;
		private var c1:Controller;
		private var c2:Controller;
		private var c3:Controller;
		private var c4:Controller;
		private var c5:Controller;
		private var c6:Controller;
		private var c7:Controller;
		private var c8:Controller;
		
		public function GraphicInterface()
		{
			addEventListener(Event.ADDED_TO_STAGE,added_handler);	
		}
		public function added_handler(e:Event):void
		{
			particleMC = new Sprite();
			particles = new Array();
			addChild(particleMC);
			
			
			c1= new Controller(100,6, 0x999999);
			c1.x=300;
			c1.y=200;
			addChild(c1);
			
			c2= new Controller(100,6, 0x660033);
			c2.x=350;
			c2.y=250;
			addChild(c2);
			
			c3= new Controller(100,6, 0x660066);
			c3.x=400;
			c3.y=300;
			addChild(c3);
			
			c4= new Controller(100,6, 0x000099);
			c4.x=350;
			c4.y=350;
			addChild(c4);
			
			c5= new Controller(100,6, 0xff0000);
			c5.x=300;
			c5.y=400;
			addChild(c5);
		
			c6= new Controller(100,6, 0x00ff00);
			c6.x=250;
			c6.y=350;
			addChild(c6);
			
			c7= new Controller(100,6, 0xffffff);
			c7.x=200;
			c7.y=300;
			addChild(c7);
			
			c8= new Controller(100,6, 0xffffff);
			c8.x=250;
			c8.y=250;
			addChild(c8);
			
			addEventListener(Event.ENTER_FRAME,onEnterFrame);
		}
		
		private function onEnterFrame(e:Event):void
		{
			
			var gradientBoxMatrix :Matrix = new Matrix();
  			gradientBoxMatrix.createGradientBox (c7.controller_value()+300,c7.controller_valua()+300, 0, 0, 0);
			
			var gradientBoxMatrixa :Matrix = new Matrix();
  			gradientBoxMatrixa.createGradientBox (c7.controller_value()+300,c7.controller_valua()+300, 0, 0, 0);
			
			createParticle();
			particleMC.graphics.clear();
			
			for(var i:int=particles.length-1;i>=0;i--) {
				particles[i].x += particles[i].dx;
				particles[i].y += particles[i].dy;
				
				var nbr:uint =  255 << 16  | Math.round(Math.abs(180-c2.controller_valua())*255/360) << 8 | Math.round(Math.abs(180-c2.controller_value())*255/360);
				var nbra:uint =  255 << 16 | Math.round(Math.abs(180-c3.controller_valua())*255/360) << 8 | Math.round(Math.abs(180-c3.controller_value())*255/360);
				var nbrb:uint =  255 << 16 | Math.round(Math.abs(180-c4.controller_valua())*255/360) << 8 | Math.round(Math.abs(180-c4.controller_value())*255/360);
				
				///////////>><< -- splice? +1
				
				particleMC.graphics.lineStyle(1,nbr,.3);
				particleMC.graphics.lineGradientStyle(GradientType.LINEAR, [nbra,nbr, nbrb], [1, 1, .6], [0, 128, 255], gradientBoxMatrix);
				
				particleMC.graphics.beginFill(nbr,.5);
				particleMC.graphics.beginGradientFill(GradientType.RADIAL, [nbrb, nbr, nbra], [1, .1, .8], [0, 255, 250], gradientBoxMatrixa);
				
				//particleMC.graphics.moveTo(300,300);
				//particleMC¨.x = mouseX;
				//particleMC.y = mouseY;
				//particleMC.graphics.lineTo(particles[i].x+Math.pow(i,.2)*Math.cos(i), particles[i].y+Math.pow(i,.2)*Math.sin(i));
				particleMC.graphics.drawRect(particles[i].x,particles[i].y,(c1.controller_value()),1);
				
				//particleMC.graphics.endFill();
				if (particles[i].life-- <= 0) {
					particles[i].dx = 0;
				    particles[i].dy = 0;
					particleMC.removeChild(particles[i]);
					particles.splice(i,1);
				}
			}
		}
		//ADAPTATION D'UNE FONCTION DE CEM DU 26_08_09
		private function createParticle():void 
		 {
			var p:MovieClip = new MovieClip();
			
			p.x = c5.controller_value()+300;
			p.y = c6.controller_valua()+300;

			//p.x = 300;
			//p.y = 300;
			
			p.life = 100;
			
			p.dx = Math.random()*Math.pow(3,1.2)*Math.cos(5);
			
			p.dy = Math.random()*Math.pow(3,1.2)*Math.sin(5);
				
			//trace (c1.controller_value());
					
			particleMC.addChild(p);
			particles.push(p);
		}
	}
}
import flash.display.Sprite;
import flash.events.MouseEvent;
import flash.events.EventDispatcher;
import flash.events.Event;

	import flash.utils.getTimer;
	import flash.geom.*;

class Controller extends Sprite{
	
		private var downPoint:Point;
		private var upPoint:Point;
		private var startTime:int;
		private var endTime:int;
		private var dx:Number;
		private var dy:Number;
		private var distance:Number;
		private var modulo:Number=100;
		private var inv:Number=1;
		public static var deltaTime:int;
		public static var angle:int;
	
	private var line:Sprite = new Sprite();
	private var angler:Sprite = new Sprite();
	
	public static var dispatcher:EventDispatcher;
	public function Controller(size:Number, siza:Number, color:uint ){
		dispatcher = new EventDispatcher();
		/*graphics.beginFill(0xffffff,0);
		graphics.lineStyle(0,0x000000,0);
		graphics.drawRect(0,0,size,siza);
		graphics.endFill();*/
		line.graphics.beginFill(color,.5);
		line.graphics.drawCircle(0,0,5);
		line.graphics.endFill();
		
		downPoint=new Point  ;
		upPoint=new Point  ;
		
		/*angler.graphics.beginFill(color,1);
		angler.graphics.lineStyle(10,0xffffff,1);
		angler.graphics.moveTo(downPoint.x,downPoint.y);
		angler.graphics.lineTo(upPoint.x,upPoint.y);
		angler.graphics.endFill();*/
		
		addChild(line);
		addChild(angler);
		
		addEventListener(MouseEvent.MOUSE_DOWN,down_handler);
	}
	private function down_handler(e:MouseEvent):void
	{
		
			downPoint.x=mouseX;
			downPoint.y=mouseY;
			startTime=getTimer();
			
			line.startDrag();
		
		addEventListener(MouseEvent.MOUSE_MOVE,move_handler);
		stage.addEventListener(MouseEvent.MOUSE_UP,up_handler);
		
	}
	private function move_handler(e:MouseEvent):void
	{
		/*var angle:Number = Math.atan(Math.round(e.localY)/Math.round(e.localX))*180/Math.PI;
		if(e.localX<0){
			angle+=180;
		}*/
		
		//e.currentTarget.line.x = e.stageX-310;
		
	}
	private function up_handler(e:MouseEvent):void
	{
		
			upPoint.x=mouseX;
			upPoint.y=mouseY;
			dx=upPoint.x - downPoint.x;
			dy=upPoint.y - downPoint.y;
			angle=180 / Math.PI * Math.atan2(dy,dx) + 180;
			distance=Point.distance(upPoint,downPoint);
			endTime=getTimer();
			deltaTime = endTime - startTime;
			//trace(distance);
			//trace(angle);
			trace(deltaTime);
			
			line.stopDrag();
		
		removeEventListener(MouseEvent.MOUSE_MOVE,move_handler);
	}
	public function controller_value():Number
	{
		return line.x;
		
		//trace (line.x);
	}
	
	public function controller_valua():Number
	{
		return line.y;
		
		//trace (line.y);
	}
	 
}